using System;
using csmic;
using PingPong.Generic;

namespace PingPong.GameEngine
{
    public class Engine
    {
		/// <summary>
		/// The input interpreter.
		/// </summary>
        private static Locked<Lazy<InputInterpreter>> inputInterpreter;
		
		#region Properties
			
		/// <summary>
		/// Gets the expression parser.
		/// </summary>
		/// <value>
		/// The expression parser.
		/// </value>
        public static InputInterpreter ExpressionParser
        { 
            get
            {
                return inputInterpreter.Value.Value;
            }
        }
		
		#endregion
		
        public Engine()
        {
			//
        }
		
        static Engine()
        {
            inputInterpreter = new Locked<Lazy<InputInterpreter>>(new Lazy<InputInterpreter>(() => new InputInterpreter()));
        }
    }
}

